k3s/hack/test-update-storage-objects.sh

211 lines
7.6 KiB
Bash
Raw Normal View History

#!/usr/bin/env bash
2015-05-05 23:53:22 +00:00
# Copyright 2014 The Kubernetes Authors.
2015-05-05 23:53:22 +00:00
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# Script to test cluster/update-storage-objects.sh works as expected.
set -o errexit
set -o nounset
set -o pipefail
KUBE_ROOT=$(dirname "${BASH_SOURCE}")/..
source "${KUBE_ROOT}/hack/lib/init.sh"
# The api version in which objects are currently stored in etcd.
2015-07-23 04:52:05 +00:00
KUBE_OLD_API_VERSION=${KUBE_OLD_API_VERSION:-"v1"}
2015-05-05 23:53:22 +00:00
# The api version in which our etcd objects should be converted to.
# The new api version
KUBE_NEW_API_VERSION=${KUBE_NEW_API_VERSION:-"v1"}
2015-05-05 23:53:22 +00:00
KUBE_OLD_STORAGE_VERSIONS=${KUBE_OLD_STORAGE_VERSIONS:-""}
KUBE_NEW_STORAGE_VERSIONS=${KUBE_NEW_STORAGE_VERSIONS:-""}
2016-03-02 15:01:19 +00:00
2016-05-17 12:44:30 +00:00
KUBE_STORAGE_MEDIA_TYPE_JSON="application/json"
KUBE_STORAGE_MEDIA_TYPE_PROTOBUF="application/vnd.kubernetes.protobuf"
2015-05-05 23:53:22 +00:00
ETCD_HOST=${ETCD_HOST:-127.0.0.1}
ETCD_PORT=${ETCD_PORT:-2379}
2016-05-31 08:42:52 +00:00
ETCD_PREFIX=${ETCD_PREFIX:-randomPrefix}
2015-05-05 23:53:22 +00:00
API_PORT=${API_PORT:-8080}
API_HOST=${API_HOST:-127.0.0.1}
RUNTIME_CONFIG=""
2016-08-16 11:59:08 +00:00
ETCDCTL=$(which etcdctl)
2015-05-05 23:53:22 +00:00
KUBECTL="${KUBE_OUTPUT_HOSTBIN}/kubectl"
UPDATE_ETCD_OBJECTS_SCRIPT="${KUBE_ROOT}/cluster/update-storage-objects.sh"
DISABLE_ADMISSION_PLUGINS="ServiceAccount,NamespaceLifecycle,LimitRanger,MutatingAdmissionWebhook,ValidatingAdmissionWebhook,ResourceQuota,PersistentVolumeLabel,DefaultStorageClass"
2015-05-05 23:53:22 +00:00
function startApiServer() {
2017-07-21 16:43:14 +00:00
local storage_versions=${1:-""}
local storage_media_type=${2:-""}
2018-04-25 20:07:15 +00:00
kube::log::status "Starting kube-apiserver with..."
kube::log::status " storage-media-type: ${storage_media_type}"
kube::log::status " runtime-config: ${RUNTIME_CONFIG}"
kube::log::status " storage-version overrides: ${storage_versions}"
2015-05-05 23:53:22 +00:00
2018-04-25 20:07:15 +00:00
"${KUBE_OUTPUT_HOSTBIN}/kube-apiserver" \
2016-03-02 15:01:19 +00:00
--insecure-bind-address="${API_HOST}" \
--bind-address="${API_HOST}" \
--insecure-port="${API_PORT}" \
2017-07-21 16:43:14 +00:00
--storage-backend="etcd3" \
--etcd-servers="http://${ETCD_HOST}:${ETCD_PORT}" \
2016-08-16 11:59:08 +00:00
--etcd-prefix="/${ETCD_PREFIX}" \
--runtime-config="${RUNTIME_CONFIG}" \
--disable-admission-plugins="${DISABLE_ADMISSION_PLUGINS}" \
--cert-dir="${TMPDIR:-/tmp/}" \
2016-03-02 15:01:19 +00:00
--service-cluster-ip-range="10.0.0.0/24" \
2016-05-17 12:44:30 +00:00
--storage-versions="${storage_versions}" \
--storage-media-type=${storage_media_type} 1>&2 &
2015-05-05 23:53:22 +00:00
APISERVER_PID=$!
# url, prefix, wait, times
2016-03-02 15:01:19 +00:00
kube::util::wait_for_url "http://${API_HOST}:${API_PORT}/healthz" "apiserver: " 1 120
2015-05-05 23:53:22 +00:00
}
function killApiServer() {
kube::log::status "Killing api server"
if [[ -n ${APISERVER_PID-} ]]; then
kill ${APISERVER_PID} 1>&2 2>/dev/null
wait ${APISERVER_PID} || true
kube::log::status "api server exited"
fi
2015-05-05 23:53:22 +00:00
unset APISERVER_PID
}
function cleanup() {
killApiServer
kube::etcd::cleanup
kube::log::status "Clean up complete"
}
trap cleanup EXIT SIGINT
make -C "${KUBE_ROOT}" WHAT=cmd/kube-apiserver
2016-03-02 15:01:19 +00:00
2015-05-05 23:53:22 +00:00
kube::etcd::start
2017-07-21 16:43:14 +00:00
echo "${ETCD_VERSION}" > "${ETCD_DIR}/version.txt"
2015-05-05 23:53:22 +00:00
2016-03-02 15:01:19 +00:00
### BEGIN TEST DEFINITION CUSTOMIZATION ###
2015-05-05 23:53:22 +00:00
2016-03-02 15:01:19 +00:00
# source_file,resource,namespace,name,old_version,new_version
tests=(
2018-03-15 22:32:24 +00:00
test/e2e/testing-manifests/rbd-storage-class.yaml,storageclasses,,slow,v1beta1,v1
2016-03-02 15:01:19 +00:00
)
KUBE_OLD_API_VERSION="networking.k8s.io/v1,storage.k8s.io/v1beta1,extensions/v1beta1"
KUBE_NEW_API_VERSION="networking.k8s.io/v1,storage.k8s.io/v1,extensions/v1beta1,policy/v1beta1"
KUBE_OLD_STORAGE_VERSIONS="storage.k8s.io/v1beta1"
KUBE_NEW_STORAGE_VERSIONS="storage.k8s.io/v1"
2016-03-02 15:01:19 +00:00
### END TEST DEFINITION CUSTOMIZATION ###
2015-05-05 23:53:22 +00:00
#######################################################
# Step 1: Start a server which supports both the old and new api versions,
# but KUBE_OLD_API_VERSION is the latest (storage) version.
2016-05-17 12:44:30 +00:00
# Additionally use KUBE_STORAGE_MEDIA_TYPE_JSON for storage encoding.
2015-05-05 23:53:22 +00:00
#######################################################
2018-04-25 20:07:15 +00:00
RUNTIME_CONFIG="api/all=false,api/v1=true,apiregistration.k8s.io/v1=true,${KUBE_OLD_API_VERSION}=true,${KUBE_NEW_API_VERSION}=true"
2017-07-21 16:43:14 +00:00
startApiServer ${KUBE_OLD_STORAGE_VERSIONS} ${KUBE_STORAGE_MEDIA_TYPE_JSON}
2016-03-02 15:01:19 +00:00
# Create object(s)
for test in ${tests[@]}; do
IFS=',' read -ra test_data <<<"$test"
source_file=${test_data[0]}
2015-05-05 23:53:22 +00:00
2016-03-02 15:01:19 +00:00
kube::log::status "Creating ${source_file}"
2018-02-05 09:54:17 +00:00
${KUBECTL} create -f "${KUBE_ROOT}/${source_file}"
2016-03-02 15:01:19 +00:00
# Verify that the storage version is the old version
resource=${test_data[1]}
namespace=${test_data[2]}
name=${test_data[3]}
old_storage_version=${test_data[4]}
if [ -n "${namespace}" ]; then
namespace="${namespace}/"
fi
kube::log::status "Verifying ${resource}/${namespace}${name} has storage version ${old_storage_version} in etcd"
2017-07-21 16:43:14 +00:00
ETCDCTL_API=3 ${ETCDCTL} --endpoints="http://${ETCD_HOST}:${ETCD_PORT}" get "/${ETCD_PREFIX}/${resource}/${namespace}${name}" | grep ${old_storage_version}
2016-03-02 15:01:19 +00:00
done
2015-05-05 23:53:22 +00:00
killApiServer
#######################################################
2017-07-21 16:43:14 +00:00
# Step 2: Start a server which supports both the old and new api versions,
2015-05-05 23:53:22 +00:00
# but KUBE_NEW_API_VERSION is the latest (storage) version.
2016-05-17 12:44:30 +00:00
# Still use KUBE_STORAGE_MEDIA_TYPE_JSON for storage encoding.
2015-05-05 23:53:22 +00:00
#######################################################
2018-04-25 20:07:15 +00:00
RUNTIME_CONFIG="api/all=false,api/v1=true,apiregistration.k8s.io/v1=true,${KUBE_OLD_API_VERSION}=true,${KUBE_NEW_API_VERSION}=true"
2017-07-21 16:43:14 +00:00
startApiServer ${KUBE_NEW_STORAGE_VERSIONS} ${KUBE_STORAGE_MEDIA_TYPE_JSON}
2015-05-05 23:53:22 +00:00
# Update etcd objects, so that will now be stored in the new api version.
2016-03-02 15:01:19 +00:00
kube::log::status "Updating storage versions in etcd"
2015-05-05 23:53:22 +00:00
${UPDATE_ETCD_OBJECTS_SCRIPT}
2016-03-02 15:01:19 +00:00
# Verify that the storage version was changed in etcd
for test in ${tests[@]}; do
IFS=',' read -ra test_data <<<"$test"
resource=${test_data[1]}
namespace=${test_data[2]}
name=${test_data[3]}
new_storage_version=${test_data[5]}
if [ -n "${namespace}" ]; then
namespace="${namespace}/"
fi
kube::log::status "Verifying ${resource}/${namespace}${name} has updated storage version ${new_storage_version} in etcd"
2017-07-21 16:43:14 +00:00
ETCDCTL_API=3 ${ETCDCTL} --endpoints="http://${ETCD_HOST}:${ETCD_PORT}" get "/${ETCD_PREFIX}/${resource}/${namespace}${name}" | grep ${new_storage_version}
2016-03-02 15:01:19 +00:00
done
2015-05-05 23:53:22 +00:00
2016-03-02 15:01:19 +00:00
killApiServer
2015-05-05 23:53:22 +00:00
2015-05-05 23:53:22 +00:00
#######################################################
2017-07-21 16:43:14 +00:00
# Step 3 : Start a server which supports only the new api version.
2016-05-17 12:44:30 +00:00
# However, change storage encoding to KUBE_STORAGE_MEDIA_TYPE_PROTOBUF.
2015-05-05 23:53:22 +00:00
#######################################################
2018-04-25 20:07:15 +00:00
RUNTIME_CONFIG="api/all=false,api/v1=true,apiregistration.k8s.io/v1=true,${KUBE_NEW_API_VERSION}=true"
# This seems to reduce flakiness.
sleep 1
2017-07-21 16:43:14 +00:00
startApiServer ${KUBE_NEW_STORAGE_VERSIONS} ${KUBE_STORAGE_MEDIA_TYPE_PROTOBUF}
2016-03-02 15:01:19 +00:00
for test in ${tests[@]}; do
IFS=',' read -ra test_data <<<"$test"
resource=${test_data[1]}
namespace=${test_data[2]}
name=${test_data[3]}
namespace_flag=""
2015-05-05 23:53:22 +00:00
2016-03-02 15:01:19 +00:00
# Verify that the server is able to read the object.
if [ -n "${namespace}" ]; then
namespace_flag="--namespace=${namespace}"
namespace="${namespace}/"
fi
kube::log::status "Verifying we can retrieve ${resource}/${namespace}${name} via kubectl"
# We have to remove the cached discovery information about the old version; otherwise,
# the 'kubectl get' will use that and fail to find the resource.
rm -rf ${HOME}/.kube/cache/discovery/localhost_8080/${KUBE_OLD_STORAGE_VERSIONS}
${KUBECTL} get ${namespace_flag} ${resource}/${name}
2016-03-02 15:01:19 +00:00
done
killApiServer